53 Commits

Author SHA1 Message Date
v4n df3c780270 fix: version number url 2025-06-20 15:09:27 +03:00
v4n 1c1235c85e fix: remove nexus upgrade delay (#63) 2025-06-20 15:07:11 +03:00
v4n 7cedfcb451 feat: added rename command (#62) 2025-06-20 11:10:41 +03:00
v4n 0fdc5a2306 fix: nexus integration does not quit prematurely 2025-05-17 14:23:44 +03:00
v4n 13dc822fd9 fix: nexus integration on Steam Deck (#55) 2025-05-16 16:59:14 +03:00
F. St. 35302aa7c7 fix: print parent folder of mod variants (#52)
* Print parent folder of mod variants

Because some mods have multiple variants with the same name.
As is, it is impossible to tell them apart in the selection.
This commit changes the selection to also print the parent folder of the
variants.

* remove the name of the mod zip/dir itself because it not necessary

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-04-19 14:57:20 +03:00
v4n ebadc049e7 fix: confirm after auto-finding HD2 path (#51) 2025-04-17 17:41:56 +03:00
v4n 649404c2d4 fix: sanitize file name of commas (fixes #48) (#49) 2025-04-16 14:54:59 +03:00
v4n 737fa01c11 feat: 7z file format support (#47) 2025-04-15 18:06:54 +03:00
v4n 0ac711085b fix: date invalid issue (fixes #46) 2025-04-15 17:56:06 +03:00
v4n 146b711a9b feat: nexus mods integration (#44)
* progress

* working download

* save details in db, display them

* progress

* progress

* progress

* progress

* i guess it's shippable

* final commit
2025-04-11 23:29:06 +03:00
v4n 5aafd2f16b fix: detailed instructions on installing in case of error 2025-04-03 00:24:02 +03:00
v4n c30d2a46a5 feat: modpack list verbose mode & improvements (#35) 2025-03-22 21:21:13 +02:00
v4n b6e92e2918 feat: install rar mods (#34) 2025-03-22 20:23:21 +02:00
v4n afbb6d3a0c fix: steam deck forgot to source bashrc 2025-03-22 19:46:07 +02:00
v4n f87b2709b0 bump: version 2025-03-20 11:54:20 +02:00
v4n 7666638328 feat: export can specify path (#33) 2025-03-20 11:53:52 +02:00
v4n 5f7f2a261a fix: mods db was deleted due to incorrect pipe 2025-03-19 23:24:34 +02:00
v4n efe8720507 fix: added temporary backup making in case mods get deleted 2025-03-19 23:01:18 +02:00
v4n cb71852068 fix: prompts for install script 2025-03-19 20:25:44 +02:00
v4n 26031c0381 version 0.4.0 release 2025-03-19 20:20:12 +02:00
Daedalusspacegames 9c73be1cb7 fix: modify date syntax to enhance compatibility with alternate coreutils implementations, such as [uutils](https://github.com/uutils/coreutils) (#29) 2025-03-19 12:10:17 +02:00
v4n a8e94c19fb feat: command to change load order of mods (#27)
* progress

* progress

* feat: progress

* progress

* done, needs more testing, pr -> change all functions to require -n before specifying name -> v0.4 (reindex db)

* testing done
2025-03-18 16:18:48 +02:00
v4n 6b968172ea fix: updating now works properly 2025-03-10 21:42:55 +02:00
v4n b3bc91522f do not update 2025-03-10 21:14:37 +02:00
v4n a7936c90bd fix: stop latest update 2025-03-10 21:07:03 +02:00
v4n 4d1af7e4a0 feat: modpack-create can select individual mods (#26) 2025-03-10 21:01:06 +02:00
v4n 0eff8afe6b fix: turned code into fn 2025-03-08 00:38:04 +02:00
v4n 3593e32a7b fix: upgrade mods was overwriting files 2025-03-07 23:24:30 +02:00
v4n 797739ea7a fix: uninstall correctly reindexes (fix #21) 2025-03-07 22:57:14 +02:00
v4n df006a7430 fix: infite loop while enabling (#25) 2025-03-07 18:20:34 +02:00
v4n 344e4348d4 fix: non important sed error 2025-03-06 04:09:45 +02:00
v4n 719217d00b bump: version 2025-03-06 01:29:45 +02:00
v4n b1930811f9 fix: segfault from infinite recursion 2025-03-06 01:29:14 +02:00
v4n d1ca18b563 bump: downgrade because of seg fault 2025-03-06 00:59:58 +02:00
v4n 5d91190dbf fix: code cleanup 2025-03-06 00:12:59 +02:00
v4n 28122ee332 feat: list is now compact, added verbose option 2025-03-05 19:09:57 +02:00
v4n 56bb73784e fix: directory checking in wrong place 2025-03-02 15:38:07 +02:00
v4n 0d8f22a2d0 fix: variants fix 2025-02-21 17:15:35 +02:00
v4n 3c6238f8d2 fix: show variants better 2025-02-21 16:16:42 +02:00
v4n a031230117 fix: bash black magic 2025-02-21 16:06:20 +02:00
v4n 77ae53ffa7 fix: weird update bug 2025-02-21 14:03:49 +02:00
v4n c23c57e16c fix: weird update bug 2025-02-21 14:01:36 +02:00
v4n 898400e526 fix: whitespace in help msg 2025-02-21 13:48:50 +02:00
v4n c45f5860d8 bump: version 2025-02-21 13:44:18 +02:00
v4n 838c834cc2 feat: easily install multiple variants (#20)
* feat: easily install multiple variants

* fix: filter only dirs that have patches
2025-02-21 13:16:29 +02:00
v4n 7b8b2fda8f fix: console output, formatting 2025-02-21 12:46:46 +02:00
Catherine Guelque 0485b56df5 There is no need to install in the global path nor to use SUDO if the given path was writtable (#18)
* There's no need for sudo + Added warning if not in PATH

* fix: removed duplicated command call

---------

Co-authored-by: v4n <105587619+v4n00@users.noreply.github.com>
2025-02-17 18:07:54 +02:00
v4n d18a9cdccf fix: formatting 2025-02-06 20:13:45 +02:00
v4n c74f4a8a00 fix: whitespace, version bump for earlier commit 2025-02-06 20:12:27 +02:00
Matt Cavanagh 9f592e7ce2 feat: added .editorconfig to ensure consistency across IDEs and to prevent line ending oopsies (#17) 2025-02-06 19:47:37 +02:00
v4n 21b1822006 fix: uninstall correctly downgrades 2025-02-06 19:43:30 +02:00
v4n dbcc7d1e96 fix: CRLF -> LF 2025-02-06 03:34:33 +02:00
6 changed files with 2291 additions and 1423 deletions
+6
View File
@@ -0,0 +1,6 @@
[*]
indent_style = tab
indent_size = 4
end_of_line = lf
insert_final_newline = true
trim_trailing_whitespace = true
+6 -5
View File
@@ -1,5 +1,6 @@
* *
!h2mm !h2mm
!install.sh !install.sh
!README.md !README.md
!version !version
!.editorconfig
+123 -164
View File
@@ -1,164 +1,123 @@
# Helldivers 2 Mod Manager CLI # Helldivers 2 Mod Manager CLI
Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born. Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born.
This script is complete, the version will always [remain at 0.x.x](https://0ver.org/) This mod manager is complete, the version will always [remain at 0.x.x](https://0ver.org/). Version 0.6.x will be the last version of this mod manager.
## Installation ## Installation
To install Helldivers 2 Mod Manager CLI run the following command in your terminal: Pre-requisites:
```bash - You must have the `unzip` package installed for zip archives;
bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)" - You might want to have the `unarchiver` package installed for rar archives.
```
To install Helldivers 2 Mod Manager CLI run the following command in your terminal:
> [!CAUTION]
> Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself. ```bash
bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"
If for some reason, the installation command doesn't work you can: ```
1. Go to <https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh> > [!CAUTION]
1. Right click -> Save page as... > Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the repository for yourself.
1. Go to your downloads folders `cd ~/Downloads`
1. Give the script execution permissions `chmod +x install.sh` ## Usage
1. Run the script `./install.sh`
The script gets added to `/usr/local/bin/h2mm` (or `$HOME/.local/bin` on Steam Deck) and can be used by running `h2mm` in your shell, which will show the help message explaining how to use the script.
## Usage
```bash
The script gets added to `/usr/local/bin/h2mm` and can be used by running `h2mm` in your shell, which will show the help message explaining how to use the script. h2mm
```
```bash
h2mm ### Available commands
```
- `install` or `i` - Install a mod by the file provided (directory, zip, patch);
### Available commands - `uninstall` or `u` - Uninstall a mod;
- `list` or `l` - List all installed mods;
- `install` - Install a mod by the file provided (directory, zip, patch). - `enable` or `e` - Enable a mod;
- `uninstall` - Uninstall a mod by name (or index). - `disable` or `d` - Disable a mod;
- `list` - List all installed mods. - `rename` or `r` - Rename a mod;
- `enable` - Enable a mod by name (or index). - `order` or `o` - Change load order for a mod;
- `disable` - Disable a mod by name (or index). - `export` or `ex` - Export installed mods to a zip file;
- `export` - Export installed mods to a zip file. - `import` or `im` - Import mods from a zip file;
- `import` - Import mods from a zip file. - `modpack-create` or `mc` - Create a modpack from the currently installed mods;
- `modpack-create` - Create a modpack from the currently installed mods. - `modpack-switch` or `ms` - Switch to a modpack;
- `modpack-switch` - Switch to a modpack by name (or index). - `modpack-list` or `ml` - List all installed modpacks;
- `modpack-list` - List all installed modpacks. - `modpack-delete` or `md` - Delete a modpack;
- `modpack-delete` - Delete a modpack by name (or index). - `modpack-overwrite` or `mo` - Overwrite a modpack;
- `modpack-overwrite` - Overwrite a modpack by name (or index). - `modpack-reset` or `mr` - Reset all installed modpacks;
- `modpack-reset` - Reset all installed modpacks. - `nexus-setup` or `ns` - Setup Nexus Mods integration;
- `reset` - Reset all installed mods. - `update` or `up` - Update h2mm to latest version;
- `update` - Update h2mm to latest version. - `reset` or `rs` - Reset all installed mods;
- `help` - Display this help message. - `help` or `h` - Display this help message.
### Basic usage ### Examples
#### Install mod(s) To find out how to use a command, you can run `h2mm <COMMAND> --help`.
```bash #### Install mod(s)
h2mm install /path/to/mod.zip
h2mm install /path/to/mod/files ```bash
h2mm install /path/to/mod.zip /path/to/mod2.zip /path/to/mod/files h2mm install mod.zip
h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files h2mm install /path/to/mod/directory/
h2mm install -n "Example mod" mod* # using a wildcard to include all files h2mm install /path/to/mod.zip /path/to/mod2.zip /path/to/mod/files # mix and match hoewever you want
``` h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files
```
> [!NOTE]
> If the mod has more than 1 variant, you need to install the one you want by unarchiving it separately and providing the directory. > It's better to be in the directory where the mod files are located, so you don't have to specify the full path. For mod downloads, you can do `cd ~/Downloads` and then run the command.
>
#### Uninstall a mod > Also, use the Tab key to autocomplete the file names, as it will help you escape special characters likes spaces or quotes.
```bash #### List installed mods
h2mm uninstall "Example mod"
h2mm uninstall -i 1 # uninstall mod with index 1 ```bash
``` h2mm list
h2mm list -v # verbose mode
#### Enable/disable mods ```
```bash #### Uninstall a mod
h2mm enable "Example mod"
h2mm enable -i 1 # enable mod with index 1 ```bash
h2mm disable "Example mod" h2mm uninstall -n "Example mod"
h2mm disable -i 1 # disable mod with index 1 h2mm uninstall -i 3 # get the index from the list command
``` ```
#### List installed mods #### Enable/disable mods
```bash ```bash
h2mm list h2mm enable -n "Example mod"
``` h2mm enable -i 3
h2mm disable -n "Example mod"
#### Updating the script h2mm disable -i 3
```
```bash
h2mm update #### Updating the script
```
```bash
## Compatibility h2mm update
```
The script is developed and tested on Arch Linux, but it should work on other Linux distributions as well. If you encounter any issues, please open an issue on the repository.
## Nexus Mods integration
Status of platforms:
Nexus Mods integration allows you to use the 1-click install feature of Nexus Mods (with the "Vortex" or "Mod manager download" buttons). You can set up Nexus Mods integration by running the following command:
- Linux :white_check_mark:
- Steam Deck :white_check_mark: ```bash
- Windows - WSL :white_check_mark: h2mm nexus-setup
```
> The script works on WSL, but you need to specify the path to the Helldivers 2 mods directory manually, to find your Windows partition head to `/mnt/` and from there go to your Helldivers 2 data directory, on a typical install it should be on `/mnt/c/Program\ Files\ \(x86\)/Steam/steamapps/common/Helldivers\ 2/data`. You also need to have `unzip` installed, which can be done by running `sudo apt install unzip`.
You will be walked through the setup process, which will ask you for your Nexus Mods API key and your preferred terminal.
## Advanced usage
## Compatibility
### Shortcuts
The script is developed and tested on Arch Linux, but it should work on other Linux distributions as well. If you encounter any issues, please open an issue on the repository.
You can use the short form of commands to save some time. The shortcuts are:
Status of platforms:
- `i` for `install`
- `u` for `uninstall` - Linux :white_check_mark:
- `e` for `enable` - Steam Deck :white_check_mark:
- `d` for `disable` - Windows - WSL :white_check_mark:
- `l` for `list`
- `ex` for `export` > The script works on WSL, but you need to specify the path to the Helldivers 2 mods directory manually, to find your Windows partition head to `/mnt/` and from there go to your Helldivers 2 data directory, on a typical install it should be on `/mnt/c/Program\ Files\ \(x86\)/Steam/steamapps/common/Helldivers\ 2/data`. You also need to have `unzip` installed, which can be done by running `sudo apt install unzip`. Nexus Mods integration is not supported on WSL.
- `im` for `import`
- `mc` for `modpack-create` ## Contributing
- `ms` for `modpack-switch`
- `ml` for `modpack-list` Feel free to contribute to this project by creating a pull request or opening an issue.
- `md` for `modpack-delete`
- `mo` for `modpack-overwrite`
- `mr` for `modpack-reset`
- `r` for `reset`
- `up` for `update`
### Modpacks support
You can set up modpacks by using the `modpack-*` commands. This allows you to quickly change between a set of mods. For more information, check the help message.
```bash
h2mm modpack-create "Modpack 1"
# install, enable, disable other mods...
h2mm modpack-create "Modpack 2"
h2mm modpack-switch "Modpack 1"
```
### Exporting and importing
You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The archive file (`.tar.gz`) will be saved in the current directory.
```bash
h2mm export modpack1.zip
h2mm import modpack2.zip
```
### Resetting all installed mods
You can reset all installed mods by running the following command. This will remove all installed mods and the database, in case things go wild.
```bash
h2mm reset
```
### Database location and details
The database is stored in the `Helldivers 2` install directory, under the `data` folder with the name `mods.csv`, where the mods are also installed. The database is a simple CSV file which you can use to manually manage mods if needed, you can mostly use it to rename or reorder mods.
## Contributing
Feel free to contribute to this project by creating a pull request or opening an issue.
+1957 -1107
View File
File diff suppressed because it is too large Load Diff
+198 -146
View File
@@ -1,146 +1,198 @@
#!/usr/bin/env bash #!/usr/bin/env bash
set -e set -e
RED='\033[0;31m' RED='\033[0;31m'
GREEN='\033[0;32m' GREEN='\033[0;32m'
ORANGE='\033[0;33m' ORANGE='\033[0;33m'
NC='\033[0m' NC='\033[0m'
DESTINATION_PATH="/usr/local/bin" DESTINATION_PATH="/usr/local/bin"
SCRIPT_NAME="h2mm" REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master"
REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master"
function log() {
if [ "$(id -u)" -eq 0 ]; then local type="$1"
echo "Run me as normal user, not as root." shift
exit 1 case "$type" in
fi INFO)
echo -e "$*" >&2
# --- Main --- ;;
ERROR)
# Warning echo -e "${RED}[ERROR]${NC} $*" >&2
;;
echo -e "!!! ${RED}WARNING${NC} !!!" PROMPT)
echo -e "This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/$SCRIPT_NAME." echo -ne "$*" >&2
echo -e "Running this script will require sudo permissions. ${RED}DO NOT TRUST${NC} random scripts from the internet." ;;
echo -e "If you want to review the script before running it, check out the mod repository for yourself:" esac
echo -e "https://github.com/v4n00/h2mm-cli" }
echo -e "!!! ${RED}WARNING${NC} !!!"
echo # --- Main ---
# Check if update # warning
# Breaking changes hash table log INFO "${RED}!!! WARNING !!!${NC}"
cat << EOF
breaking_changes_patches=( This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/h2mm.
["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"' Running this script will require sudo permissions. DO NOT TRUST random scripts from the internet.
["3"]='sed -i "1 i\\3" "$1/mods.csv"' If you want to review the script before running it, check out the repository for yourself:
) https://github.com/v4n00/h2mm-cli
EOF
# Handle breaking changes log INFO "${RED}!!! WARNING !!!${NC}"
log INFO ""
if [[ -x "$(command -v $SCRIPT_NAME)" ]]; then
installed_version=$($SCRIPT_NAME --version) # breaking changes hash table
# version 1 show the help message, if the first character is not a 0, store installed version as 0.1.6 breaking_changes_patches=(
[[ ${installed_version:0:1} != "0" ]] && { installed_version="0.1.6"; } ["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"'
["3"]='sed -i "1 i\\3" "$1/mods.csv"'
latest_version=$(curl -sS "$REPO_URL"/version) ["4"]='tmp_file=$(mktemp) && awk '\''BEGIN {FS=OFS=","} NR==1 {print 4; next} {print NR-1, $2, $3, $4, $5}'\'' "$1/mods.csv" > "$tmp_file" && tee "$1/mods.csv" < "$tmp_file" > /dev/null && rm "$tmp_file"'
if [[ "$latest_version" == "$installed_version" ]]; then ["5"]='sed -i "s/^\([0-9]\+\),\(.*\),\(.*\),\(.*\)/\1,\2,\3,,,,\4/" "$1/mods.csv"; sed -i "1 s/4/5/" "$1/mods.csv"'
echo -e "You are reinstalling version $installed_version." ["6"]='sed -i "s/^\([0-9]\+\),\(.*\),\(.*\),\(.*\),\(.*\),\(.*\),\(.*\)/\1,\2,\3,\4,\6,\7/" "$1/mods.csv"; sed -i "1 s/5/6/" "$1/mods.csv"'
else )
echo -e "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}."
fi # notify if update is happening
installed_version=""
# split version numbers latest_version=""
installed_major="" if [[ -x "$(command -v h2mm)" ]]; then
latest_major="" installed_version=$(h2mm --version)
IFS='.' read -r _1 installed_major _2 <<< "$installed_version"
IFS='.' read -r _1 latest_major _2 <<< "$latest_version" # if installed version isn't x.x.x crash
if [[ ! "$installed_version" =~ ^[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
if [[ $latest_major -gt $installed_major ]]; then log ERROR "Installed version is not in the correct format."
echo -e "${ORANGE}Warning:${NC} Major version upgrade detected." log ERROR "h2mm is installed here -> $(which h2mm)"
echo "${ORANGE}Info${NC}: Check out the changelogs here -> https://github.com/v4n00/h2mm-cli/releases" log ERROR "Delete the script file and retry the install script, any mods installed will not be lost."
echo "The script will proceed to upgrade ${SCRIPT_NAME} to avoid breaking changes." log INFO 'Download using the command: bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"'
exit 1
# find hd2 path fi
search_dir="${HOME}"
target_dir="Steam/steamapps/common/Helldivers\ 2/data" latest_version=$(curl -sS "$REPO_URL"/version)
echo "Searching for the Helldivers 2 data directory... (20 seconds timeout)" >&2 if [[ "$latest_version" == "$installed_version" ]]; then
log INFO "You are reinstalling version ${GREEN}$installed_version${NC}."
game_dir=$(timeout 20 find "$search_dir" -type d -path "*/$target_dir" 2>/dev/null | head -n 1) else
if [[ -z "$game_dir" ]]; then log INFO "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}."
echo "Could not find the Helldivers 2 data directory automatically." >&2 fi
IFS= read -ep "Please enter the path to the Helldivers 2 data directory: " game_dir fi
if [[ ! -d "$game_dir" ]]; then
echo -e "${RED}Error${NC}: Provided path is not a valid directory." >&2 # if steam deck, set destination path to ~/.local/bin
exit 1 log PROMPT "Are you installing on a Steam Deck? (y/N): "
fi IFS= read -e response_sd
fi
if [[ "$response_sd" == "y" || "$response_sd" == "Y" ]]; then
[[ ! -f "$game_dir/mods.csv" ]] && { echo -e "${RED}Error:${NC} mods.csv not found in $game_dir."; exit 1; } # steam deck
DESTINATION_PATH="$HOME/.local/bin"
# make backup of mods in case something goes wrong mkdir -p "$DESTINATION_PATH"
echo "${ORANGE}V${NC} It is advised to make a backup before proceeding."
h2mm export # check if ~/.local/bin is in PATH
if [[ ":$PATH:" != *":$HOME/.local/bin:"* ]]; then
# iterate from installed major number to latest major number # add ~/.local/bin to PATH
for ((i = installed_major + 1; i <= latest_major; i++)); do log INFO "Installing the script on a Steam Deck means adding $DESTINATION_PATH to your \$PATH."
if [[ -n "${breaking_changes_patches[$i]}" ]]; then log INFO "If you're using a different shell than bash (the default), you may need to add it manually."
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:")
else log PROMPT "Do you want to add $DESTINATION_PATH to your \$PATH in ~/.bashrc? (Y/n): "
echo "No breaking changes for version $i." IFS= read -e response
fi if [[ "$response" == "y" || "$response" = "Y" || -z "$response" ]]; then
if [[ $? -ne 0 ]]; then echo "export PATH=\"\$HOME/.local/bin:\$PATH\"" >> "$HOME/.bashrc"
echo -ne "${RED}Error:${NC} Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): " [[ $? -ne 0 ]] && { log ERROR "Failed to add $DESTINATION_PATH to \$PATH in ~/.bashrc." ; exit 1; }
read -er response
source "$HOME/.bashrc"
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { echo "Exiting. Uninstall the script first the retry the install script."; exit 1; } export PATH="$HOME/.local/bin:$PATH" # fallback kinda in case sourcing fails
else
echo -e "Breaking changes patch for version ${ORANGE}$i${NC} applied ${GREEN}successfully${NC}." log INFO "Added $DESTINATION_PATH to your \$PATH in ~/.bashrc."
fi fi
done fi
fi else
echo # not steam deck
fi # set another path if needed
log PROMPT "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): "
# Install IFS= read -e response
# if steam deck, set destination path to ~/.local/bin if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then
IFS= read -ep "Are you installing on a Steam Deck? (y/N): " response_sd DESTINATION_PATH="$response"
if [[ "$response_sd" == "y" || "$response_sd" == "Y" ]]; then [[ ! -d "$DESTINATION_PATH" ]] && { log ERROR "Path $DESTINATION_PATH does not exist." ; exit 1; }
# steam deck fi
DESTINATION_PATH="$HOME/.local/bin" fi
mkdir -p "$DESTINATION_PATH"
# handle breaking changes
# check if ~/.local/bin is in PATH installed_major=$(echo "$installed_version" | awk -F. '{print $2}')
if [[ ":$PATH:" != *":$HOME/.local/bin:"* ]]; then latest_major=$(echo "$latest_version" | awk -F. '{print $2}')
# add ~/.local/bin to PATH
echo -e "${ORANGE}Warning:${NC} Installing the script on a Steam Deck means adding $DESTINATION_PATH to your \$PATH." if [[ $latest_major -gt $installed_major ]]; then
echo -e "${ORANGE}Warning:${NC} If you're using a different shell, you may need to add it manually." log INFO ""
log INFO "${GREEN}IMPORTANT${NC}: Major version upgrade detected. Check out the changelogs here -> https://github.com/v4n00/h2mm-cli/releases"
IFS= read -ep "Do you want to add $DESTINATION_PATH to your \$PATH in ~/.bashrc? (Y/n): " response log INFO "The script will proceed to upgrade the database file. Creating a backup in case anything goes wrong."
if [[ "$response" == "y" || "$response" = "Y" || -z "$response" ]]; then
echo "export PATH=\"\$HOME/.local/bin:\$PATH\"" >> "$HOME/.bashrc" # make backup
echo -e "${GREEN}Success:${NC} Added $DESTINATION_PATH to your \$PATH in ~/.bashrc." h2mm export
fi
fi # check if game directory is in ~/.config/h2mm/h2path
else if [[ -f "$HOME/.config/h2mm/h2path" ]]; then
# not steam deck game_dir=$(cat "$HOME/.config/h2mm/h2path")
# set another path if needed [[ ! -d "$game_dir" ]] && { log ERROR "Helldivers 2 data directory is not valid: $game_dir." ; exit 1; }
IFS= read -ep "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): " response else
log INFO "Searching for the Helldivers 2 data directory... (10 seconds timeout)"
if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then game_dir=$(timeout 10 find "$HOME" -type d -path "*/Steam/steamapps/common/Helldivers\ 2/data" 2>/dev/null | head -n 1)
DESTINATION_PATH="$response" fi
[[ ! -d "$DESTINATION_PATH" ]] && { echo -e "${RED}Error:${NC} Path $DESTINATION_PATH does not exist."; exit 1; }
fi # if not found, prompt user
fi if [[ -z "$game_dir" ]]; then
# if not found, ask user for the directory
echo "Installing $SCRIPT_NAME to $DESTINATION_PATH." log INFO "Could not find the Helldivers 2 data directory automatically."
sudo curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME" log PROMPT "Please enter the path to the Helldivers 2 data directory: "
sudo chmod +x "$DESTINATION_PATH/$SCRIPT_NAME" IFS= read -e game_dir; unset IFS
game_dir="$(substitute_home "$game_dir")"
if [[ ! -x "$(command -v $SCRIPT_NAME)" ]]; then
echo -e "${RED}Error:${NC} Installation failed." [[ ! -d "$game_dir" ]] && { log ERROR "Provided path is not a valid directory."; exit 1; }
exit 1 else
fi # confirm with the user that the directory is ok
log INFO "Found Helldivers 2 data directory: $game_dir"
echo "Helldivers 2 Mod Manager CLI installed successfully to $DESTINATION_PATH/$SCRIPT_NAME. Use it by running '$SCRIPT_NAME'." log PROMPT "Is this the correct directory? (Y/n): "
read confirm
if [[ "$confirm" != "y" && "$confirm" != "Y" && "$confirm" != "" ]]; then
log PROMPT "Please enter the path to the Helldivers 2 data directory: "
IFS= read -e game_dir; unset IFS
game_dir="$(substitute_home "$game_dir")"
[[ ! -d "$game_dir" ]] && { log ERROR "Provided path is not a valid directory."; exit 1; }
fi
fi
[[ ! -f "$game_dir/mods.csv" ]] && { log ERROR "mods.csv not found in $game_dir." ; exit 1; }
# iterate from installed major number to latest major number
for ((i = installed_major + 1; i <= latest_major; i++)); do
if [[ -n "${breaking_changes_patches[$i]}" ]]; then
# apply breaking changes patch
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:g")
else
log INFO "No breaking changes for version $i."
continue
fi
if [[ $? -ne 0 ]]; then
log ERROR "Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
read -er response
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { log INFO "Exiting." ; exit 1; }
else
log INFO "Version upgrade fix ${GREEN}successfully${NC} applied for version $i."
fi
done
log INFO ""
fi
# install
log INFO "Installing h2mm to $DESTINATION_PATH."
sudo curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/h2mm"
sudo chmod +x "$DESTINATION_PATH/h2mm"
log INFO ""
[[ ! -x "$(command -v h2mm)" ]] && { log ERROR "Installation failed. Mod manager was not found in \$PATH." ; exit 1; }
log INFO "Helldivers 2 Mod Manager CLI ${GREEN}successfully${NC} installed."
log INFO "${GREEN}IMPORTANT${NC}: To install mods, you need to have installed:"
log INFO " -> \"unzip\" package for .zip archives"
log INFO " -> \"unarchiver\" package for .rar archives"
log INFO "If you do not know how to install these packages, please search for your linux distro on how to install packages."
log INFO ""
log INFO "Use the mod manager by running 'h2mm' in your terminal."
log INFO "Check out the Nexus Mods integration by running 'h2mm nexus-setup'."
log INFO "Made with love <3 by v4n and contributors."
+1 -1
View File
@@ -1 +1 @@
0.3.5 0.6.0